'use strict';

angular.module('datasid.attendance', []).
    config(function($stateProvider, $httpProvider) {
        $stateProvider.
            state('attendance', {
                abstract: true,
                url: '/attendance',
                controller: 'AttendanceCtrl',
                template: '<div ui-view></div>'
            }).

            state('attendance.index', {
                url: '',
                templateUrl: 'partials/attendance.html',
                section: 'attendance'
            }).

            state('attendance.telecentrosbr', {
                abstract: true,
                url: '/telecentrosbr',
                templateUrl: 'partials/attendance.telecentrosbr.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.gesac', {
                abstract: true,
                url: '/gesac',
                templateUrl: 'partials/attendance.gesac.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.cidades-digitais', {
                abstract: true,
                url: '/cidades-digitais',
                templateUrl: 'partials/attendance.cidades-digitais.html',
                section: 'attendance',
                project: 'cidades-digitais'
            }).

            /* AVAILABILITY CIDADES DIGITAIS */
            state('attendance.cidades-digitais.availability', {
                url: '/availability',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.nodata.html',
                section: 'attendance',
                project: 'cidades-digitais'
            }).            

            /* AVAILABILITY TELECENTROS BR*/
            state('attendance.telecentrosbr.availability', {
                url: '/availability',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.availability-region', {
                url: '/availability/:region',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.availability-state', {
                url: '/availability/:region/:state',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.availability-city', {
                url: '/availability/:region/:state/:city',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            /* AVAILABILITY GESAC */
            state('attendance.gesac.availability', {
                url: '/availability',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.availability-region', {
                url: '/availability/:region',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.availability-state', {
                url: '/availability/:region/:state',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.availability-city', {
                url: '/availability/:region/:state/:city',
                controller: 'AvailCtrl',
                templateUrl: 'partials/attendance.availability.html',
                section: 'attendance',
                project: 'gesac'
            }).

            /* NETWORK USAGE CIDADES DIGITAIS */
            state('attendance.cidades-digitais.network_usage', {
                url: '/cidades-digitais',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.nodata.html',
                section: 'attendance',
                project: 'cidades-digitais'
            }).

            /* NETWORK USAGE TELECENTROS BR */
            state('attendance.telecentrosbr.network_usage', {
                url: '/network_usage',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.network_usage-region', {
                url: '/network_usage/:region',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.network_usage-state', {
                url: '/network_usage/:region/:state',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.network_usage-city', {
                url: '/network_usage/:region/:state/:city',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            state('attendance.telecentrosbr.network_usage-telecenter', {
                url: '/network_usage/:region/:state/:city/:id_point',
                controller: 'NetworkUsageTelecenterCtrl',
                templateUrl: 'partials/attendance.network_usage.telecenter.html',
                section: 'attendance',
                project: 'tlbr'
            }).

            /* NETWORK USAGE GESAC */
            state('attendance.gesac.network_usage', {
                url: '/network_usage',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.network_usage-region', {
                url: '/network_usage/:region',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.network_usage-state', {
                url: '/network_usage/:region/:state',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.network_usage-city', {
                url: '/network_usage/:region/:state/:city',
                controller: 'NetworkUsageCtrl',
                templateUrl: 'partials/attendance.network_usage.html',
                section: 'attendance',
                project: 'gesac'
            }).

            state('attendance.gesac.network_usage-telecenter', {
                url: '/network_usage/:region/:state/:city/:id_point',
                controller: 'NetworkUsageTelecenterCtrl',
                templateUrl: 'partials/attendance.network_usage.telecenter.html',
                section: 'attendance',
                project: 'gesac'
            });

    }).

    factory('AvailFactory', function($resource) {
        return $resource('/api/:project/:type/:region/:state/:city/:id_point');
    }).

    controller('AttendanceCtrl', function ($scope, $rootScope) {
    }).

    controller('AvailCtrl', function ($scope, $rootScope, $state, $location, AvailFactory) {
        $scope.barChart = {
            render: function (element) {
                var config = jQuery.extend(true, {}, DefaultCharts.barChart);
                config.chart.renderTo = element[0];
                config.plotOptions.series.events = {
                    click: function(event) {
                        $scope.$apply(function () {
                            $scope.barChart.click(event);
                        });
                    }
                };

                $scope.barChart.chart = new Highcharts.Chart(config);
                $scope.barChart.load();
            },

            click: function (event) {
                if (typeof $state.params.state !== 'undefined') {
                    window.open('/api/reports/'+$state.current.project+'/avail_report/'+event.point.category[0], '_blank');
                }
                else
                    $location.path($location.path() + '/' + event.point.category[0]);
            },

            load: function () {
                var options = {
                    project: $state.current.project,
                    region: $state.params.region || null,
                    state: $state.params.state || null,
                    city: $state.params.city || null,
                    id_point: $state.params.id_point || null
                };

                if (typeof $state.params.city !== 'undefined')
                    options.type = 'avail_sub_telecenters';
                else if (typeof $state.params.state !== 'undefined')
                    options.type = 'avail_sub_cities';
                else if (typeof $state.params.region !== 'undefined')
                    options.type = 'avail_sub_states';
                else
                    options.type = 'avail_sub_regions';

                if (options.type === 'avail_sub_regions') {
                    $scope.barChart.chart.options.xAxis[0].labels.rotation = -45;
                }
                else {
                    $scope.barChart.chart.options.xAxis[0].labels.rotation = 0;
                }

                AvailFactory.query(options, function (data) {
                    var categories = [],
                        green = [],
                        yellow = [],
                        red = [];

                    $scope.barChart.chart.options.chart.defaultSeriesType = 'column';
                    $scope.barChart.chart.options.chart.height = 300;
                    if (data.length > 10) {
                        $scope.barChart.chart.options.chart.height = 30*data.length;
                        $scope.barChart.chart.options.chart.defaultSeriesType = 'bar';
                    }

                    for (var i=0; i<data.length; i++) {
                        var d = data[i];
                        categories.push([d.id, d.cat]);
                        green.push(parseInt(d.green));
                        yellow.push(parseInt(d.yellow));
                        red.push(parseInt(d.red));
                    }

                    $scope.barChart.chart = new Highcharts.Chart($scope.barChart.chart.options);
                    $scope.barChart.chart.render();

                    $scope.barChart.chart.xAxis[0].setCategories(categories);
                    $scope.barChart.chart.series[0].setData(green);
                    $scope.barChart.chart.series[1].setData(yellow);
                    $scope.barChart.chart.series[2].setData(red);
                });
            }
        };

        $scope.pieChart = {
            render: function (element) {
                var config = jQuery.extend(true, {}, DefaultCharts.pieChart);
                config.chart.renderTo = element[0];

                $scope.pieChart.chart = new Highcharts.Chart(config);
                $scope.pieChart.load();
            },

            load: function () {
                var options = {
                    project: $state.current.project,
                    type: 'avail_current',
                    region: $state.params.region || null,
                    state: $state.params.state || null,
                    city: $state.params.city || null,
                    id_point: $state.params.id_point || null
                };

                AvailFactory.query(options, function (data) {
                    $scope.pieChart.chart.series[0].setData([
                        ['Menos de\n10 dias', parseInt(data[0].green)],
                        ['Entre 11\ne 30 dias', parseInt(data[0].yellow)],
                        ['Mais de\n30 dias', parseInt(data[0].red)]
                    ]);
                });
            }
        };

        $scope.histChart = {
            render: function (element) {
                var config = jQuery.extend(true, {}, DefaultCharts.histChart);
                config.chart.renderTo = element[0];

                $scope.histChart.chart = new Highcharts.Chart(config);
                $scope.histChart.load();
            },

            load: function () {
                var options = {
                    project: $state.current.project,
                    type: 'avail_hist',
                    region: $state.params.region || null,
                    state: $state.params.state || null,
                    city: $state.params.city || null,
                    id_point: $state.params.id_point || null
                };

                AvailFactory.query(options, function (data) {
                    var categories = [],
                        green = [],
                        yellow = [],
                        red = [];

                    for (var i=0; i<data.length; i++) {
                        var d = data[i];
                        categories.push(d.month);
                        green.push(parseInt(d.green));
                        yellow.push(parseInt(d.yellow));
                        red.push(parseInt(d.red));
                    }

                    $scope.histChart.chart.xAxis[0].setCategories(categories);
                    $scope.histChart.chart.series[0].setData(green);
                    $scope.histChart.chart.series[1].setData(yellow);
                    $scope.histChart.chart.series[2].setData(red);
                });
            }
        };
    }).

    /* NETWORK USAGE */
    factory('NetworkUsageFactory', function($resource) {
        return $resource('/api/:project/:type/:region/:state/:city/:id_point');
    }).

    controller('NetworkUsageCtrl', function ($scope, $rootScope, $state, $location, NetworkUsageFactory) {
        $scope.barChart = {
            render: function (element) {
                var config = jQuery.extend(true, {}, DefaultCharts.barChart);
                config.yAxis.title.text = 'Média de Uso de Rede (Kb/s)';
                config.series = [
                    {name: 'Download'},
                    {name: 'Upload'}
                ];
                config.colors = [
                    '#2f7ed8',
                    '#0d233a'
                ];
                config.tooltip.formatter = function() {
                    var s = '<b>'+ this.x[1] +'</b>';

                    for (var i = 0; i < this.points.length; i++) {
                        var point = this.points[i];
                        s += '<br/><span>' + point.series.name + '</span>: ' +
                                point.y + ' Kb/s';
                    }
                    return s;
                };
                config.chart.renderTo = element[0];
                config.plotOptions.series.events = {
                    click: function(event) {
                        $scope.$apply(function () {
                            $location.path($location.path() + '/' + event.point.category[0]);
                        });
                    }
                };

                $scope.barChart.chart = new Highcharts.Chart(config);
                $scope.barChart.load();
            },

            load: function () {
                var options = {
                    project: $state.current.project,
                    region: $state.params.region || null,
                    state: $state.params.state || null,
                    city: $state.params.city || null,
                    id_point: $state.params.id_point || null
                };

                if (typeof $state.params.city !== 'undefined')
                    options.type = 'net_usage_sub_telecenters';
                else if (typeof $state.params.state !== 'undefined')
                    options.type = 'net_usage_sub_cities';
                else if (typeof $state.params.region !== 'undefined')
                    options.type = 'net_usage_sub_states';
                else
                    options.type = 'net_usage_sub_regions';

                if (options.type === 'net_usage_sub_regions') {
                    $scope.barChart.chart.options.xAxis[0].labels.rotation = -45;
                }
                else {
                    $scope.barChart.chart.options.xAxis[0].labels.rotation = 0;
                }

                NetworkUsageFactory.query(options, function (data) {
                    var categories = [],
                        down = [],
                        up = [];

                    $scope.barChart.chart.options.chart.defaultSeriesType = 'column';
                    $scope.barChart.chart.options.chart.height = 300;
                    if (data.length > 10) {
                        $scope.barChart.chart.options.chart.height = 30*data.length;
                        $scope.barChart.chart.options.chart.defaultSeriesType = 'bar';
                    }

                    for (var i=0; i<data.length; i++) {
                        var d = data[i];
                        categories.push([d.id, d.cat]);
                        down.push(parseInt(d.down));
                        up.push(parseInt(d.up));
                    }

                    $scope.barChart.chart = new Highcharts.Chart($scope.barChart.chart.options);
                    $scope.barChart.chart.render();

                    $scope.barChart.chart.xAxis[0].setCategories(categories);
                    $scope.barChart.chart.series[0].setData(down);
                    $scope.barChart.chart.series[1].setData(up);
                });
            }
        };
    }).

    controller('NetworkUsageTelecenterCtrl', function ($scope, $state, $location, NetworkUsageFactory) {
        $scope.netusageChart = {
            render: function (element) {
                var config = jQuery.extend(true, {}, DefaultCharts.netusageChart);
                config.chart.renderTo = element[0];

                var options = {
                    project: $state.current.project,
                    type: 'net_usage_telecenter',
                    region: $state.params.region || null,
                    state: $state.params.state || null,
                    city: $state.params.city || null,
                    id_point: $state.params.id_point || null
                };

                NetworkUsageFactory.query(options, function (data) {
                    var down = [], up = [];

                    for (var i=0; i<data.length; i++) {
                        config.series[0].data.push([data[i].timestamp * 1000, data[i].down]);
                        config.series[1].data.push([data[i].timestamp * 1000, data[i].up]);
                    }

                    $scope.netusageChart.chart = new Highcharts.StockChart(config);
                });
            }
        };
    });
